//------------------------------------------------------------------------------
// tesout.cpp - тестовый вывод информации о лексемах
//------------------------------------------------------------------------------

#include <stdio.h>
#include "scanner_ext.h"

//------------------------------------------------------------------------------

int const buf_size = 256;

//------------------------------------------------------------------------------

void fprintlex(FILE* f) 
{
  char* lcs;
  char* lvs;

  switch(lc) 
  {
    case lexPlus:       lcs=(char*)"lexPlus";      lvs=(char*)"+";  break;
    case lexAssign:     lcs=(char*)"lexAssign";    lvs=(char*)":="; break;
    case lexComma:      lcs=(char*)"lexComma";     lvs=(char*)",";  break;
    case lexComment:    lcs=(char*)"lexComment";   lvs=lv;   break;
    case lexSlash:      lcs=(char*)"lexSlash";     lvs=(char*)"/";  break;
    case lexColon:      lcs=(char*)"lexColon";     lvs=(char*)":";  break;
    case lexEQ:         lcs=(char*)"lexEQ";        lvs=(char*)"=";  break;
    case lexEof:        lcs=(char*)"lexEof";       lvs=(char*)"-1"; break;
    case lexError:      lcs=(char*)"lexError";     lvs=lv;   break;
    case lexFloat:      
      lcs=(char*)"lexFloat";     lvs=lv;   
      fprintf(f, "[%d, %d]    \tlc: %s\t\tlv: %s\t\tdnum = %e\n", 
        line, column, lcs, lvs, dnum);  
      //printf("[%d, %d]    \tlc: %s\t\tlv: %s\t\tdnum = %e\n", 
      //  line, column, lcs, lvs, dnum);  
      return;
      //break;
    case lexGE:         lcs=(char*)"lexGE";        lvs=(char*)">="; break;
    case lexGT:         lcs=(char*)"lexGT";        lvs=(char*)">";  break;
    case lexId:         lcs=(char*)"lexId";        lvs=lv;   break;
    case lexIgnore:     lcs=(char*)"lexIgnore";    lvs=lv;   break;
    case lexInt:        
      lcs = (char*)"lexInt";
      lvs = lv;
      fprintf(f, "[%d, %d]    \tlc: %s\t\tlv: %s\t\tunum = %u\n", 
        line, column, lcs, lvs, unum);  
      //printf("[%d, %d]    \tlc: %s\t\tlv: %s\t\tunum = %u\n", 
      //  line, column, lcs, lvs, unum);  
      return;
      //break;
    case lexLE:         lcs=(char*)"lexLE";        lvs=(char*)"<="; break;
    case lexLftRndBr:   lcs=(char*)"lexLftRndBr";  lvs=(char*)"(";  break;
    case lexLftSqBr:    lcs=(char*)"lexLftSqBr";   lvs=(char*)"[";  break;
    case lexLT:         lcs=(char*)"lexLT";        lvs=(char*)"<";  break;
    case lexPercent:    lcs=(char*)"lexPercent";   lvs=(char*)"%";  break;
    case lexStar:       lcs=(char*)"lexStar";      lvs=(char*)"*";  break;
    case lexString:     lcs=(char*)"lexString";    lvs=lv;   break;
    case lexNE:         lcs=(char*)"lexNE";        lvs=(char*)"!="; break;
    case lexSemicolon:  lcs=(char*)"lexSemicolon"; lvs=(char*)";";  break;
    case lexRghRndBr:   lcs=(char*)"lexRghRndBr";  lvs=(char*)")";  break;
    case lexRghSqBr:    lcs=(char*)"lexRghSqBr";   lvs=(char*)"]";  break;
    case lexSkip:       lcs=(char*)"lexSkip";      lvs=(char*)" ";  break;
    case lexArrow:      lcs=(char*)"lexArrow";     lvs=(char*)"->"; break;
    case lexMinus:      lcs=(char*)"lexMinus";     lvs=(char*)"-";  break;

    case kwAbort:       lcs=(char*)"KWABORT";      lvs=lv;   break;
    case kwBegin:       lcs=(char*)"KWBEGIN";      lvs=lv;   break;
    case kwCase:        lcs=(char*)"KWCASE";       lvs=lv;   break;
    case kwEnd:         lcs=(char*)"KWEND";        lvs=lv;   break;
    case kwFloat:       lcs=(char*)"KWFLOAT";      lvs=lv;   break;
    case kwGoto:        lcs=(char*)"KWGOTO";       lvs=lv;   break;
    case kwInt:         lcs=(char*)"KWINT";        lvs=lv;   break;
    case kwLoop:        lcs=(char*)"KWLOOP";       lvs=lv;   break;
    case kwOr:          lcs=(char*)"KWOR";         lvs=lv;   break;
    case kwRead:        lcs=(char*)"KWREAD";       lvs=lv;   break;
    case kwSkip:        lcs=(char*)"KWSKIP";       lvs=lv;   break;
    case kwSpace:       lcs=(char*)"KWSPACE";      lvs=lv;   break;
    case kwTab:         lcs=(char*)"KWTAB";        lvs=lv;   break;
    case kwVar:         lcs=(char*)"KWVAR";        lvs=lv;   break;
    case kwWrite:       lcs=(char*)"KWWRITE";      lvs=lv;   break;

    default:            lcs=(char*)"nonprinted lex class"; lvs=lv;
  }
  fprintf(f, "[%d, %d]    \tlc: %s\t\tlv: %s\n", line, column, lcs, lvs);  
  //printf("[%d, %d]    \tlc: %s\t\tlv: %s\n", line, column, lcs, lvs);  
}
